function output = inp_func(k, inp_structure, dim, diam, noise)

mat_inp=zeros(sqrt(dim),sqrt(dim));
for ni=1:length(inp_structure)
    if diam==1
        coord{ni}=round(inp_structure{ni}(k,:)*10);
    else
        coord{ni}=[floor(inp_structure{ni}(k,:)*10), (inp_structure{ni}(k,:)*10)-floor(inp_structure{ni}(k,:)*10)];
    end
end

for i=1:length(inp_structure)
    ax=coord{i}(1,1);
    ay=coord{i}(1,2);
    if ax>0 && ay>0
        if diam==1
            mat_inp(ax, ay)=1;
        elseif diam==2
            axp=coord{i}(1,3);
            ayp=coord{i}(1,4);
            mat_inp(ax, ay)=((1-axp)+(1-ayp))/2;
            if ax<dim
                mat_inp(ax+1, ay)=axp;
            end
            if ay<dim
                mat_inp(ax, ay+1)=ayp;
            end
            if ax<dim && ay<dim
                mat_inp(ax+1, ay+1)=(axp+ayp)/2;
            end
        else
            error('not optimised for diameters above 2')
        end
    end
end

mat_inp=mat_inp+(rand(10,10)/10)*noise;

output = mat_inp;